﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Threading.Tasks;

namespace FastReg
{
	public class FastReg
	{

		public String regexString { get; set; }
		public String inputString { get; set; }
		public String outputString { get; set; }

		private String actualLine = "";

		public String betweenMarkeds { get; set; }	// Találatok közé tett karakter

		private bool enableDebugTrace = true;

		public int progressStatusPercent { get; set; }
		private int actualCnt;
		private int inputFullLength;

		public delegate void SetProgressDelegateType(int value);
		public SetProgressDelegateType SetProgressDelegate { get; set; }

		public bool isRunning { get; set; }
		public ManualResetEvent regFinishEvent;


		public void Process()
		{

			outputString = "";

			inputFullLength = inputString.Length;
			actualCnt = 0;
			progressStatusPercent = 0;

			if (inputFullLength == 0)
			{
				// Wrong input text!
				return;
			}

			while (actualCnt < inputFullLength)
			{

				// Search a line start
				actualCnt = DropStartNewlineCharacters(actualCnt);
				
				// Firsts newline characters dropped

				int endCnt = SearchFirstNewLineCharacter(actualCnt);
				// Has ended

				// Create one line string
				actualLine = inputString.Substring(actualCnt, (endCnt-actualCnt));

				//////////////// Progress /////////////////////////
				ProcessOneLine();
				//////////////// End	  /////////////////////////

				// Step to next
				actualCnt += actualLine.Length;

				CalculateProgressBar();

			}

			isRunning = false;
			regFinishEvent.Set();
			return;

		}



		private void CalculateProgressBar()
		{
			// Check at Process() function
			//if(inputFullLength != 0)

			progressStatusPercent = (int)((float)((float)actualCnt / (float)inputFullLength) * 100);
			//SetProgressDelegate(progressStatusPercent);
			//FormFastReg._FormFastReg.SetProgressBar(progressStatusPercent);

		}



		public void ProcessOneLine()
		{


			// Regex
			/*
			string url = "http://www.contoso.com:8080/letters/readme.html";
			Regex r = new Regex(@"^(?<proto>\w+)://[^/]+?(?<port>:\d+)?/",RegexOptions.None, TimeSpan.FromMilliseconds(150));
			Match m = r.Match(url);
			if (m.Success)
				Console.WriteLine(r.Match(url).Result("${proto}:${port}")); 

			// The example displays the following output: 
			//       http:8080

			*/

			// Link from Regex: http://vbence.web.elte.hu/regex_leiras.html
			// https://en.wikipedia.org/wiki/Regular_expression

			Regex r;
			Match m;

			/*
			pattern =		@"(?<MasterOrSlave>[MS]{1})" +  // Master/Slave
							@"(?<ChannelAtempHex>[0-9A-F]{4})" +
							@"(?<SetTempHex>[0-9A-F]{4})" +
							@"(?<MasterErrorCode_SlaveBuzzerDelay>[0-9A-F]{2})" +
							@"(?<MasterFix_SlaveRelay>[0-9A-F]{2})" +
							@"(?<Checksum>[0-F]{2})" +
							@" " +  // Space
									// Temperatures
							@"(?<Temp1integer>\d{2})" + @"." + @"(?<Temp1part>\d{1})" + @" " +
							@"(?<Temp2integer>\d{2})" + @"." + @"(?<Temp2part>\d{1})" + @" " +
							@"(?<Temp3integer>\d{2})" + @"." + @"(?<Temp3part>\d{1})" + @" " +
							@"(?<Temp4integer>\d{2})" + @"." + @"(?<Temp4part>\d{1})" + @" " +
							@"(?<Temp5integer>\d{2})" + @"." + @"(?<Temp5part>\d{1})" + @" " +
							// Error
							@"(?<MasterErrorCode>[0-9A-F]{2})" +
							@"(?<BuzzerDelay>[0-9A-F]{2})" +
							@"(?<ControlDelay>[0-9A-F]{2})" +
							@" " +  // Space
							@"(?<RelayState>[+-]{3})" +
							@"[F ]" +  // F or Space
							@" " +  // Space
							@"(?<Version>[0-9.]{4})";
							// \r\n
			*/

			r = new Regex(regexString, RegexOptions.None, TimeSpan.FromMilliseconds(25));

			m = r.Match(actualLine);


			// End of Regex

			if (m.Success)
			{

				// Print
				/*
				if (enableDebugTrace)
				{
					//Console.WriteLine(r.Match(url).Result("MasterOrSlave ${MasterOrSlave}\n"));

				}   // End of if (enableDebugTrace)
				*/

				// Example:
				// MasterOrSlave
				//String MasterOrSlave = m.Groups["MasterOrSlave"].Value;

				// Skip first "param", because it is the original line
				for (int i=1; i < m.Groups.Count; i++)
				{
					outputString += m.Groups[i].Value;
					outputString += betweenMarkeds;
				}

				outputString += Environment.NewLine;
			}
			else
			{
				//outputString = "";
			}

			// Newline
			//outputString += Environment.NewLine;


		}   // End of process



		// String processers


		private int SearchFirstNewLineCharacter(int index)
		{

			// newline characters

			for (; index < inputString.Length; index++)
			{
				if((inputString[index] == '\r') ||
					(inputString[index] == '\n') ||
					(inputString[index] == '\0')
					)
				{
					return index;
				}
			}

			return inputString.Length;

		}



		private bool IsStartNewLineCharacter(int index)
		{

			// Is start with end character?
			if ((inputString[index] == '\r') ||
				(inputString[index] == '\n') ||
				(inputString[index] == '\0')
				)
			{
				return true;
			}
			else
			{
				return false;
			}
		}



		private int DropStartNewlineCharacters(int index)
		{

			for (; index < inputString.Length; index++)
			{
				// Is start with end character?
				if ((inputString[index] == '\r') ||
					(inputString[index] == '\n') ||
					(inputString[index] == '\0')
					)
				{
					// Next step, because this character is newline character
				}
				else
				{
					// This character is not newline character
					// The cnt is good "start cnt"
					return index;
				}
			}

			return 0;

		}




	}
}
